//+------------------------------------------------------------------+
//|                                                    
//|                                      
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Smoky's Trendscalper modified by TR_n00btrader@frisurf.no"
#property link      "http://www.metaquotes.net/"
extern int       MagicNumber   = 20056789;
extern double    TakeProfit    = 100;
extern double    StopLoss      = 45;
extern double    TrailingStop  = 70;
extern double    Lots          = 1;
extern int       BB2period=100;
extern double    BB2multiplier=0.95;
extern int       TTFperiod=15;
extern color clOpenBuy         = Blue;
extern color clOpenSell        = Red;
extern color clModiBuy         = LightBlue;
extern color clModiSell        = Orange;
extern string Name_Expert      = "TrendScalper_TR";
extern bool UseSound           = true;
extern string NameFileSound    = "alert.wav";
extern int Slippage            = 3;


// program variables
double Opentrades,orders,first,mode,cnt,Ilo,sym,b;
double b4signal,Signal,Triggerline,b4Triggerline,Nowsignal,NowTriggerline,sl,LastOpByExpert,LastBarChecked;
int total;



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
//------------------------------------------------------------------------------------------------ 
   Opentrades=0;
   for (cnt=0;cnt<OrdersTotal();cnt++) 
   {
      if ( OrderSelect (cnt, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol()==Symbol()) Opentrades=Opentrades+1;
   }


   if (Opentrades==0)  
   
     {
  
     if (LastBarChecked == Time[0]) 
         return(0); 
      else 
  	      {
  	      LastBarChecked = Time[0]; 
  	      //if (! High[1]>iBands(Symbol(),0,BB2period,2,0,PRICE_CLOSE,MODE_UPPER,1) && ! Low[1]<iBands(Symbol(),0,BB2period,2,0,PRICE_CLOSE,MODE_LOWER,1)) 
  	      if (! High[1]>(iMA(Symbol(),0,BB2period,0,MODE_SMA,PRICE_CLOSE,1) + ((iBands(Symbol(),0,BB2period,2,0,PRICE_CLOSE,MODE_UPPER,1) - iMA(Symbol(),0,BB2period,0,MODE_SMA,PRICE_CLOSE,1)) *BB2multiplier)) && ! Low[1]<(iMA(Symbol(),0,BB2period,0,MODE_SMA,PRICE_CLOSE,1) - ((iMA(Symbol(),0,BB2period,0,MODE_SMA,PRICE_CLOSE,1) - iBands(Symbol(),0,BB2period,2,0,PRICE_CLOSE,MODE_LOWER,1)) * BB2multiplier)))
  	         return(0);
  	      }
   	
	   

      double HHR,HHO,LLR,LLO;
      double BP,SP;

	  HHR=High[Highest(Symbol(), 0, MODE_HIGH,1,0+1)];
	  HHO =High[Highest(Symbol(), 0, MODE_HIGH,TTFperiod,0+1+1)];
	  LLR =Low [Lowest (Symbol(), 0, MODE_LOW,1,0+1)];
	  LLO =Low [Lowest (Symbol(), 0, MODE_LOW,TTFperiod,0+1+1)];
	  BP =HHR-LLO;
	  SP=HHO -LLR;
	  Triggerline=(BP-SP)/(0.5*(BP+SP))*100;
	  if (Triggerline>=0) Triggerline= 100; else Triggerline=-100;

	  HHR=High[Highest(Symbol(), 0, MODE_HIGH,1,1+1)];
	  HHO =High[Highest(Symbol(), 0, MODE_HIGH,TTFperiod,1+1+1)];
	  LLR =Low [Lowest (Symbol(), 0, MODE_LOW ,1,1+1)];
	  LLO =Low [Lowest (Symbol(), 0, MODE_LOW ,TTFperiod,1+1+1)];
	  BP =HHR-LLO;
	  SP=HHO -LLR;
	  b4Triggerline=(BP-SP)/(0.5*(BP+SP))*100;
	  if (b4Triggerline>=0) b4Triggerline=100; else b4Triggerline=-100;

     //Print (Triggerline, "   ", b4Triggerline);



     if (b4Triggerline>=100
     && High[1]>(iMA(Symbol(),0,BB2period,0,MODE_SMA,PRICE_CLOSE,1) + ((iBands(Symbol(),0,BB2period,2,0,PRICE_CLOSE,MODE_UPPER,1) - iMA(Symbol(),0,BB2period,0,MODE_SMA,PRICE_CLOSE,1)) * BB2multiplier))
     && Triggerline<100) 
  
        {
        OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,Name_Expert,MagicNumber,0,clOpenSell);
        LastOpByExpert=CurTime();
        //	Print (TimeToStr(Time[1]),"   ", Triggerline);
        PlaySound(NameFileSound);
        return(0);            
        }

     if 
     (b4Triggerline<=(-100) 
     && Low[1]<(iMA(Symbol(),0,BB2period,0,MODE_SMA,PRICE_CLOSE,1) - ((iMA(Symbol(),0,BB2period,0,MODE_SMA,PRICE_CLOSE,1) - iBands(Symbol(),0,BB2period,2,0,PRICE_CLOSE,MODE_LOWER,1)) * BB2multiplier))
     && Triggerline>(-100)) //and iATR(10,1)>6*Point

        {
        OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,Name_Expert,0,0,clOpenBuy);
        LastOpByExpert=CurTime();
        PlaySound(NameFileSound);
        return(0);
        }

     }

   //----------------------------------------Order Control-------------------------------------------
 
  ManageStop();
  return(0);
  }
//+------------------------------------------------------------------+

void ManageStop()
{
  if(Opentrades  > 0 )
  {
     
     total= OrdersTotal();
     for(cnt = 0; cnt < OrdersTotal(); cnt++)
     {
        OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
        if(OrderSymbol() == Symbol() && OrderType() == OP_BUY)
        {
          if(Ask-OrderOpenPrice() > (TrailingStop * Point ))
          {
            if( OrderStopLoss() < (Ask - TrailingStop * Point ))
            {
             OrderModify(OrderTicket(),OrderOpenPrice(),Ask-TrailingStop*Point,Ask+TakeProfit*Point,0,clModiBuy);  
             if(UseSound){
             PlaySound(NameFileSound);
             }
             return(0);
            }
          }
        } // OPBUY
        
        if(OrderSymbol() == Symbol() && OrderType() == OP_SELL)
        {
           if(OrderOpenPrice() - (Bid > TrailingStop * Point ))
           {
              if (OrderStopLoss() > (Bid + TrailingStop * Point ))
              {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Bid+TrailingStop*Point,Bid-TakeProfit*Point,0,clModiSell);
                 if(UseSound)
                 {
                   PlaySound(NameFileSound);
                 } 
                 return(0);
              }
              
           }
        } // OP_SELL
     } // For Loop
  } // If Opentrades > 0
}